
#include <sys/types.h>
#include <sys/sysmp.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <cpuset.h>
#include <errno.h>

main(int argc, char *argv[])
{
  int verbose = 0;
  char *usage = "%s: [-v]\n";
  char *qname = "runset";
  int i;

  /* Read the arguments */

  if (argc > 2 ) { /* Prevent any buffer problems */
    fprintf(stderr,usage,argv[0]);
    exit(0);
  }

  for (i = 1; i < argc; i++) {
    if (strcmp(argv[i],"-v") == 0) {
      verbose = 1;
    }
    else if (strcmp(argv[i],"-help") == 0 ||
	     strcmp(argv[i],"-h") == 0 ||
	     strcmp(argv[i],"-?") == 0) {
      fprintf(stderr,usage,argv[0]);
      exit(0);
    }
    else {
      fprintf(stderr,usage,argv[0]);
      exit(0);
    }
  }


  /* Stop a running cpuset */

  if (verbose) {
    printf("%s: closing cpu set \"%s\"\n",argv[0],qname);
  }
  if (!cpusetDetachAll(qname)) {
    fprintf(stderr,"%s: error detaching processes from cpuset \"%s\"\n",
            argv[0], qname);
    exit(1);
  }
  if (!cpusetDestroy(qname)) {
    fprintf(stderr,"%s: error destroying cpuset \"%s\"\n", argv[0], qname);
    exit(1);
  }
  exit(0);
}
