#!/usr/bin/perl -w

use strict;
use Env;
use Getopt::Long;
$Getopt::Long::passthrough = 1;
$Getopt::Long::ignorecase = 0;

my $options={};
GetOptions($options, '-e:s', '-n:s', '-f:s', '-x:s', '-o:s');

if ( !defined( $$options{'e'} && $$options{'n'} && $$options{'f'}
	       && $$options{'o'} && $$options{'x'})){
    print "Usage: $0 -e path -o old_type{generic,linux} -n new_type{generic,linux} -f file -x executable_name\n";
    exit(1);
}

my $answer_file = "$CMISS_EXAMPLES/$$options{'e'}/testing/diff/$$options{'o'}/".
    "$$options{'f'}";
my $diff_file = "$CMISS_EXAMPLES/$$options{'e'}/output/$$options{'x'}/".
    "$$options{'f'}.diff";
my $new_file = "$CMISS_EXAMPLES/$$options{'e'}/testing/diff/$$options{'n'}/".
    "$$options{'f'}";

if (!-e $answer_file or !-e $diff_file){
    print "$answer_file or $diff_file do not exist\n";
    exit(1);
}

print "Executing:\n patch $answer_file $diff_file -o $new_file";
print `patch $answer_file $diff_file -o $new_file`;
chmod 0644,$new_file;

