#!/usr/bin/tcsh

$template_path

if ($ARGV < 3)
  {
	 print "Usage: $0 example_repository example cm_executable\n";
	 exit;
  }


cat $template_path
# test_header.com
open (INPUTFILE, "<$template_path/test_header.com")
  || die "can't open $template_path/test_header.com: $!\n";
print FILE <INPUTFILE>;
close INPUTFILE;

# example directory
print FILE "set directory example $example_name\n";

# example_##.com
open (INPUTFILE, "<$example_dir/cmiss_input/$example_comfile.com")
  || die "can't open $example_dir/cmiss_input/$example_comfile.com: $!\n";
print FILE <INPUTFILE>;
close INPUTFILE;

# test_pre_output.com
open (INPUTFILE, "<$template_path/test_pre_output.com")
  || die "can't open $template_path/test_pre_output.com: $!\n";
print FILE <INPUTFILE>;
close INPUTFILE;

# test_output.com
open (INPUTFILE, "<$example_dir/cmiss_input/test_output.com")
  || die "can't open $example_dir/cmiss_input/test_output.com: $!\n";
print FILE <INPUTFILE>;
close INPUTFILE;

# test_post_output.com
open (INPUTFILE, "<$template_path/test_post_output.com")
  || die "can't open $template_path/test_post_output.com: $!\n";
print FILE <INPUTFILE>;
close INPUTFILE;

#Completed temporary comfile
close FILE;

# Do the execution in a forked process and watch with the parent.

$command = "$cm_executable $temp_comfile_name > $test_output 2>&1 < /dev/null";
# Fork so that we can time/watch the execution of the comfile
if (!($pid = fork()))
  {
	 # This is where the child process comes to.
	 # Execute cm with this comfile, does not return, watch with parent.
	 exec $command;
	 # Should never get here.
	 die "Unable to run: $command";
  }

# This is the parent process.
print "Executing command: $command\n";
my $start_time = time();
print "Time: " . localtime($start_time) . "\n";

waitpid($pid, 0);

my $end_time = time();
print "Completed execution\n";
print "Time: ". localtime($end_time) . "\n";
printf "Execution time in seconds: %d\n", ($end_time - $start_time);
my @cpu_times = times();
print "CPU times: @cpu_times\n";

($failed_output_ref, $diff_output_ref) = 
  test_cmiss::compare_files($example_dir, $compare_version, $diff_programs_path);

test_cmiss::generate_mail($example_dir, $example_path, $compare_version,
	 $result_path, $result_lock_file, $diff_output_ref, $failed_output_ref);

